#include <cstdio>
#include <cstdlib>

#if defined(WIN32)
//#  pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#  pragma comment(lib, "glew32.lib")
#  include "glew.h"
#  include "glut.h"
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  define GL_GLEXT_PROTOTYPES
#  include <GL/glut.h>
#endif

#include "glsl.h"

static int width, height;   // XN[̕ƍ

#define FBOWIDTH  512       // t[obt@IuWFNg̕
#define FBOHEIGHT 512       // t[obt@IuWFNg̍

static GLuint fb;           // t[obt@IuWFNg
static GLuint cb;           // J[obt@p̃eNX`
static GLuint rb;           // fvXobt@p̃_[obt@

/*
** 
*/
static void init(void)
{
#if defined(WIN32)
  // GLEW ̏
  GLenum err = glewInit();
  if (err != GLEW_OK) {
    fprintf(stderr, "Error: %s\n", glewGetErrorString(err));
    exit(1);
  }
#endif

  // J[obt@p̃eNX`pӂ
  glGenTextures(1, &cb);
  glBindTexture(GL_TEXTURE_2D, cb);
  glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, FBOWIDTH, FBOHEIGHT, 0, GL_RGBA, GL_UNSIGNED_BYTE, 0);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);

  // fvXobt@p̃_[obt@pӂ
  glGenRenderbuffersEXT(1, &rb);
  glBindRenderbufferEXT(GL_RENDERBUFFER_EXT, rb);
  glRenderbufferStorageEXT(GL_RENDERBUFFER_EXT, GL_DEPTH_COMPONENT, FBOWIDTH, FBOHEIGHT);
  glBindRenderbufferEXT(GL_RENDERBUFFER_EXT, 0);

  // t[obt@IuWFNg쐬
  glGenFramebuffersEXT(1, &fb);
  glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, fb);
  
  // t[obt@IuWFNgɃJ[obt@ƂăeNX`
  glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, GL_TEXTURE_2D, cb, 0);
  
  // t[obt@IuWFNgɃfvXobt@Ƃă_[obt@
  glFramebufferRenderbufferEXT(GL_FRAMEBUFFER_EXT, GL_DEPTH_ATTACHMENT_EXT, GL_RENDERBUFFER_EXT, rb);
  
  // t[obt@IuWFNǧ
  glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0);

  // wiF
  glClearColor(0.0f, 0.0f, 0.0f, 1.0f);

  // 
  glEnable(GL_LIGHT0);
}

/*
** ʕ\
*/
static void display(void)
{
  // ϊs̐ݒ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(30.0, (GLdouble)width / (GLdouble)height, 1.0, 10.0);

  // fr[ϊs̐ݒ
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluLookAt(3.0, 4.0, 5.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
  
  // r[|[g̐ݒ
  glViewport(0, 0, FBOWIDTH, FBOHEIGHT);

  // BʏLɂ
  glEnable(GL_DEPTH_TEST);

  // AetLɂ
  glEnable(GL_LIGHTING);

  // t[obt@IuWFNg
  glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, fb);

  // J[obt@ƃfvXobt@NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  // V[̕`
  glutSolidTeapot(1.0);
  glFlush();

  // t[obt@IuWFNǧ
  glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0);

  // ϊsPʍsɂ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();

  // fr[ϊsPʍsɂ
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  // r[|[g̓EBhẼTCYɍ킹
  glViewport(0, 0, width, height);

  // AetƉBʏ͍sȂ
  glDisable(GL_LIGHTING);
  glDisable(GL_DEPTH_TEST);

  // eNX`}bsOLɂ
  glBindTexture(GL_TEXTURE_2D, cb);
  glEnable(GL_TEXTURE_2D);

  // ``
  glColor3d(1.0, 1.0, 1.0);
  glBegin(GL_TRIANGLE_FAN);
  glTexCoord2d(0.0, 0.0);
  glVertex2d(-1.0, -1.0);
  glTexCoord2d(1.0, 0.0);
  glVertex2d( 1.0, -1.0);
  glTexCoord2d(1.0, 1.0);
  glVertex2d( 1.0,  1.0);
  glTexCoord2d(0.0, 1.0);
  glVertex2d(-1.0,  1.0);
  glEnd();

  // eNX`}bsO𖳌ɂ
  glDisable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D, 0);

  glFlush();
}

/*
** EBhETCY̕ύX
*/
static void resize(int w, int h)
{
  // EBhẼTCYۑ
  width = w;
  height = h;
}

/*
** L[{[h
*/
static void keyboard(unsigned char key, int x, int y)
{
  switch (key) {
  case 'q':
  case 'Q':
  case '\033':
    // ESC  q  Q ^CvI
    exit(0);
  default:
    break;
  }
}

/*
** CvO
*/
int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH);
  glutCreateWindow("FBO Sample");
  glutDisplayFunc(display);
  glutReshapeFunc(resize);
  glutKeyboardFunc(keyboard);
  init();
  glutMainLoop();
  return 0;
}
